<html>
  <head>
    <title>TP Vue.js Leaflet</title>
  </head>
  <body>
    <div id="app">
      <address>
        From
        <ul>
          <li>
            Road: {{ from.road }}
          </li>
          <li>
            Zip code: {{ from.zipCode }}
          </li>
          <li>
            City: {{ from.city }}
          </li>
          <li v-if="from.complement">
            Complement: {{ from.complement }}
          </li>
          <li v-if="from.country">
            Country: {{ from.country }}
          </li>
          <li v-if="from.state">
            State: {{ from.state }}
          </li>
        </ul>
        <button @click="addressToEdit = from">Modifier cette adresse</button>
      </address>
      <br>
      <address>
        To
        <ul>
          <li>
            Road: {{ to.road }}
          </li>
          <li>
            Zip code: {{ to.zipCode }}
          </li>
          <li>
            City: {{ to.city }}
          </li>
          <li v-if="to.complement">
            Complement: {{ to.complement }}
          </li>
          <li v-if="to.country">
            Country: {{ to.country }}
          </li>
          <li v-if="to.state">
            State: {{ to.state }}
          </li>
        </ul>
        <button @click="selectAddressToEdit(to)">Modifier cette adresse</button>
      </address>

      <div v-if="addressToEdit">
        <h2>Formulaire généré</h2>
        <form>
          <div v-for="item in addressSchema">
            <label>{{item.label}}</label>
            <input
              v-bind="item.attrs"
              v-model="addressToEdit[item.field]"
            />
          </div>
          <button @click="addressToEdit = null">
            X Fermer
          </button>
        </form>
      </div>

    </div>
    <script src="https://unpkg.com/vue"></script>
    <script type="text/javascript">
      /**
       * Étape 1 : Créer un "bloc" d'adresse (sans VueJS)
       * 
       * Étape 2 : Définir une variable réactive
       * 
       * Étape 3 : Affichage conditionnel de données
       * 
       * Étape 4 : Créer un formulaire dynamique
       * 
       * Étape 5 : ajouter un hook à notre application
       * 
       * Étape 6 : permettre la modification de `from` ou `to`
       */
       Vue.createApp({
        data () {
          return {
            from: {
              road: '11 rue du Marchix',
              zipCode: '44000',
              city: 'Nantes',
              complement: 'Makina Corpus',
              country: 'Pays de la Loire' // ici, nous ne déclarons pas la variable "state"
            },
            to: {
              road: 'Château des ducs de Bretagne',
              zipCode: 44000,
              city: 'Nantes',
              state: 'France'
            },
            addressSchema: [{
              attrs: { type: 'text' },
              label: 'Road',
              field: 'road'
            }, {
              attrs: { type: 'number', style: "color: red" },
              label: 'Zip Code',
              field: 'zipCode'
            }, {
              attrs: { type: 'text' },
              label: 'Complement',
              field: 'complement'
            }, {
              attrs: { type: 'text' },
              label: 'State',
              field: 'state'
            }, {
              attrs: { type: 'text' },
              label: 'Country',
              field: 'country'
            }, {
              attrs: { type: 'text' },
              label: 'City',
              field: 'city'
            }],
            addressToEdit: null
          }
        },
        methods: {
          selectAddressToEdit(address) {
            this.addressToEdit = address
          }
        },
        beforeCreate () {
          console.log('coucou, je suis presque né !', this.$data)
          // la ligne suivante casserait car le modèle de donnée n'a pas encore été instancié
          // this.from.city = 'Toulouse 1 !'
        },
        created () {
          console.log('coucou, je viens d être créé !', this.$data, this.from.city)
          this.from.city = 'Toulouse 2 !'
        },
        beforeMount () {
          console.log('coucou, je vais apparaître dans le DOM... !', this.$data, this.from.city)
          this.from.city = 'Toulouse 3 !'
        },
        mounted () {
          console.log('me voilà !', this.$data, this.from.city)
          this.from.city = 'Toulouse 4 !'
        }
       }).mount('#app')
    </script>
  </body>
</html>